<?php
namespace com\nestdesign\WpJobManagerApi2;
class AdminAjax {
  use OutputTrait;

  static public $processClass = '\\com\\nestdesign\\WpJobManagerApi2\\ProcessRequest';

  static public function init() {
    add_action('wp_ajax_nopriv_'.Main::ADMINAJAX_ACTION_PREFIX, function () {
      self::output_result(AdminAjax::showEndpoints(self::get_posted_data()));
    });
    add_action('wp_ajax_'.Main::ADMINAJAX_ACTION_PREFIX, function () {
      self::output_result(AdminAjax::showEndpoints(self::get_posted_data()));
    });
    $cls = self::$processClass;
    foreach($cls::endpoints() as $name=>$fn_name) {
      $endpoint = Main::ADMINAJAX_ACTION_PREFIX.'_'.$name;
      add_action('wp_ajax_nopriv_'.$endpoint, function () use ($fn_name, $cls) {
        self::output_result($cls::$fn_name(self::get_posted_data()));
      });
      add_action('wp_ajax_'.$endpoint, function () use ($fn_name, $cls) {
        self::output_result($cls::$fn_name(self::get_posted_data()));
      });
    }
  }
  static protected function showEndpoints() {
    $cls = self::$processClass;
    return array_keys($cls::endpoints());
  }
  static protected function do_read_xml($xml, $parent_name = null) {
    $out = array();
    $i = 0;
    foreach($xml as $elm) {
      $k = $elm->getName() === 'item' || !is_null($parent_name) && 'sub'.$parent_name === $elm->getName() ? $i++ : $elm->getName();
      if(count($elm -> children()) > 0) {
        $out[$k] = self::do_read_xml($elm, $elm->getName());
      } else {
        $out[$k] = (string)$elm;
      }
    }
    return $out;
  }
  static protected function get_posted_data() {
    if(self::is_json($_SERVER['CONTENT_TYPE'])) {
      return json_decode(file_get_contents('php://input'), true);
    } else if(self::is_xml($_SERVER['CONTENT_TYPE'])) {
      return self::do_read_xml(simplexml_load_string(file_get_contents('php://input')));
    }
    return $_POST;
  }
}
AdminAjax::init();


?>
