<?php
namespace com\nestdesign\WpJobManagerApi2\Applications;
use com\nestdesign\WpJobManagerApi2\Main;

class NooJobApplication extends Application {
  static public function init() {
    add_action( 'new_job_application', function ($post_id) {
      if (get_post_type($post_id) === 'noo_application') {
        $application = get_post($post_id);
        if ($application->post_status === 'pending') {
          $job = get_post($application->post_parent);
          $attachments = array();
          $dir = wp_upload_dir();
          foreach(get_post_meta($post_id, '_attachment') as $url) {
            //now strip the domain & replace with uploads path
            $path = str_replace($dir['baseurl'], $dir['basedir'], $url);
            if(function_exists('curl_file_create'))
              $attachments['attachment'.($file_i++)] = curl_file_create($path, '', basename($path));
            else
              $attachments['attachment'.($file_i++)] = "@$path";
          }
          self::submit_apply_notification($job, $_REQUEST, $attachments, get_post_meta($job->ID, '_application_email', true));
        }
      }
    }, 10);
    add_filter('jm_job_custom_fields', function ($fields) {
      $opt = get_option(Main::OPTION_ENABLE_APPLICATION_NOTIFICATION);
      if($opt === '1') {
        $fields[Main::META_APPLICATION_URL] = array(
          'name' => Main::META_APPLICATION_URL,
          'label' => __('Application Notification URL', 'wp-job-manager-api2'),
          'plural' => __('Application Notification URLs', 'wp-job-manager-api2'),
          'icon' => 'dashicons|',
          'type' => 'text',
          'required' => false,
          'permission' => 'administrator',
          'is_disabled' => false,
          'is_default' => true,
        );
      }
      return $fields;
    });
  }
}

NooJobApplication::init();
