<?php
namespace com\nestdesign\WpJobManagerApi2\Applications;
use com\nestdesign\WpJobManagerApi2\Main;

class WPCF7 extends Application {
  static public function init() {
    add_filter( 'wpcf7_mail_components', 'com\nestdesign\WpJobManagerApi2\Applications\WPCF7::add_phpmailer_update', 10, 1);
    add_action(Main::ACTION_DISPLAY_APPLY_FORM, '\com\nestdesign\WpJobManagerApi2\Applications\WPCF7::displayApplicationForm');
    add_filter('job_manager_settings', function ($settings) {
      $settings['wp_job_manager_api2'][1][] = array(
        'name'  => Main::OPTION_APPPLY_FORMS,
        'subname' => 'wpcf7',
        'label' => __( 'Apply with Contact Form 7', 'wp-job-manager-api2' ),
        'type' => 'wp_job_manager_api2_apply_wpcf7_form',
        'desc' => __('Select the Contact Form 7 form to show on the Job Detail page', 'wp-job-manager-api2'),
      );
      return $settings;
    }, 11, 1);
    add_action('wp_job_manager_admin_field_wp_job_manager_api2_apply_wpcf7_form', function ($option, $attributes, $value, $placeholder = null) {
      $val = isset($value[$option['subname']]) ? $value[$option['subname']] : null;
      $cf7Forms = get_posts( array('post_type' => 'wpcf7_contact_form', 'posts_per_page' => -1) );
      echo '<select name="'.htmlspecialchars($option['name'].'['.$option['subname'].']', ENT_QUOTES).'">';
      if(!empty($cf7Forms)) {
        echo '<option value="">'.__('-- select --', 'wp-job-manager-api2').'</option>';
        foreach ( $cf7Forms as $form) {
          echo '<option value="'.$form->ID.'"'.((int)$val === (int)$form->ID ? ' selected="selected"' : '').'>'.$form->post_title.'</option>';
        }
      } else {
        echo '<option value="">'.__('-- No Forms Found --', 'wp-job-manager-api2').'</option>';
      }
      echo '</select>';
      if(!empty($option['desc'])) {
        echo '<p class="description">'.$option['desc'].'</p>';
      }
    }, 10, 4);
  }
  static public function displayApplicationForm() {
    $apply = get_option(Main::OPTION_APPPLY_FORMS);
    if(!empty($apply['wpcf7'])) {
      echo do_shortcode('[contact-form-7 id="'.$apply['wpcf7'].'" title=""]');
    }
  }
  static public function add_phpmailer_update($aa) {
    add_filter('wp_mail', 'com\nestdesign\WpJobManagerApi2\Applications\WPCF7::change_email', 10, 1);
    return $aa;
  }
  static public function change_email($attrs) {
    $pid = !empty($_REQUEST['_wpcf7_container_post']) ? (int)$_REQUEST['_wpcf7_container_post'] : url_to_postid($_SERVER['HTTP_REFERER']);
    $post = get_post($pid);
    if($post->post_type === Main::currentPostType() && Application::shouldAttempNotify()) {
      self::submit_apply_notification($post, $_REQUEST, isset($attrs['attachments']) ? self::attachmentsFromRequest($attrs['attachments']) : array());
      if(strpos($attrs['to'], '{') === false) {
        $attrs['to'] = get_post_meta($pid, Main::META_APPLICATION, true);
        $attrs['message'] .= "\n".'job: '.(get_permalink($pid));
        $attrs['subject'] = html_entity_decode(get_the_title($pid)).(!empty($attrs['subject']) ? ' - '.$attrs['subject'] : '');
      }
    }
    return $attrs;
  }
  protected static function attachmentsFromRequest($attachments) {
    $data = array();
    $file_i = 0;
    foreach($attachments as $_k => $file) {
      $k = $_k;
      foreach($_FILES as $__k => $v) {
        if(is_array($v['name'])) {
          //we have multiple :-(
          foreach($v['name'] as $nm) {
            if(stripos($file, sanitize_file_name($nm)) !== false) {
              $k = $__k;
              break;
            }
          }
        } else {
          if(stripos($file, sanitize_file_name($v['name'])) !== false) {
            $k = $__k;
          }
        }
      }
      if(function_exists('curl_file_create'))
        $data[$k.($file_i++)] = curl_file_create($file);
      else
        $data[$k.($file_i++)] = "@$file";
    }
    return $data;
  }
}
WPCF7::init();


