<?php
namespace com\nestdesign\WpJobManagerApi2;

class TermMeta {
  use CreateTermTrait;
  public static function init() {
    foreach(array(
      'job_listing_salary_currency' => array(
        Main::META_TAX_SYMBOL =>  array(__('Symbol', 'wp-job-manager-api2'), 'text')
      ),
      'job_listing_salary_frequency' => array(
        Main::META_TAX_FREQUENCY =>  array(__('Salary String', 'wp-job-manager-api2'), 'text')
      ),
    ) as $tax => $fields) {
      foreach($fields as $key => list($title, $type)) {
        add_action( $tax.'_edit_form_fields', function ($tag) use ($title, $key) { self::show_the_edit(true, $tag, $title, $key); }, 10, 1 );
        add_action( $tax.'_add_form_fields', function () use ($title, $key) { self::show_the_edit(false, null, $title, $key); }, 10);
      }
      //add_action( 'edited_job_listing_salary_currency', function , 10, 2 );
      add_action( 'edit_terms', function ($term_id, $taxonomy) use ($tax, $fields) {
        if($taxonomy === $tax) {
          foreach($fields as $key => $settings) {
            update_term_meta($term_id, $key, $_REQUEST[$key]);
          }
        }
      }, 10, 2);
    }
  }
  function show_the_edit($table = false, $tag = null, $title, $key) {
    $cur = '';
    if(!empty($tag))
      $cur = get_term_meta($tag->term_id, $key, true);
    $lbl = '<label for="'.htmlspecialchars($key, ENT_QUOTES).'">'.$title.'</label>';
    if($table)
      echo '<tr><th>'.$lbl.'</th><td>';
    else
      echo '<div class="form-field '.$key.'-wrap">'.$lbl;
    ?>
      <input type="text" id="<?php echo htmlspecialchars($key, ENT_QUOTES); ?>" name="<?php echo htmlspecialchars($key, ENT_QUOTES); ?>" value="<?php echo htmlspecialchars($cur, ENT_QUOTES); ?>" />
    <?php
    if($table) {
      echo '</td></tr>';
    } else {
      echo '</div>';
    }
  }
}
TermMeta::init();
?>
