<?php

if(!class_exists('WP_Job_Manager_TW_API')) {
class WP_Job_Manager_TW_API {
  static public function displaySalary($pid = null) {
    if(is_null($pid)) {
      $pid = get_the_id();
    }
    $salary_min = get_post_meta($pid, '_salary_min', true);
    $salary_max = get_post_meta($pid, '_salary_max', true);
    $salary_negotiable = get_post_meta($pid, '_salary_negotiable', true);
    $salary_frequency = get_post_meta($pid, '_salary_frequency', true);
    $salary_currency = get_post_meta($pid, '_salary_currency', true);

    return WP_Job_Manager_TW_API::printSalary($salary_min, $salary_max, !empty($salary_negotiable), '', $salary_frequency, $salary_currency);
  }
  static public function printSalary($salary, $salary_max, $negotiable, $param = '', $_frequency = 'annual', $_currency = 'eur') {
    if($negotiable || empty($salary)) {
      $title = 'Negotiable';
      include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
      if(function_exists('is_plugin_active') && is_plugin_active('sitepress-multilingual-cms/sitepress.php')) {
        $title = icl_t('Wp Job Manager API2', 'salary negotiable', 'Negotiable');
      }
      return $title;
    }
    $frequency = strToLower($_frequency);
    $currency = strToLower($_currency);

    $currency_term = get_term_by('slug', $currency, 'job_listing_salary_currency');
    $frequency_term = get_term_by('slug', $frequency, 'job_listing_salary_frequency');

    $symbol = '';
    if(!empty($currency_term) && !is_wp_error($currency_term)) {
      $symb = get_term_meta($currency_term->term_id, '_symbol', true);
      if(!empty($symb)) {
        $symbol = $symb;
      }
    }
    $append = '';
    if(!empty($frequency_term) && !is_wp_error($frequency_term)) {
      $str = get_term_meta($frequency_term->term_id, '_salary_string', true);
      if(!empty($str)) {
        $append = ' '.trim($str);
      }
    }
    $decimal = 0;
    $sep_dec = '.';
    $sep_tho = '';
    if($frequency === 'hour')
      $decimal = 2;

    if($param == 'short') {
      if(!empty($salary) and (substr($salary, strlen($salary)-3, strlen($salary))) == '000')
        $salary = (substr($salary, 0, strlen($salary)-3))."k";
      if(!empty($salary_max) and (substr($salary_max, strlen($salary_max)-3, strlen($salary_max))) == '000')
        $salary_max = (substr($salary_max, 0, strlen($salary_max)-3))."k";

      if(empty($salary) AND !empty($salary_max))
        return self::showSalary($salary_max, $symbol).$append;
      if(!empty($salary) AND empty($salary_max))
        return self::showSalary($salary, $symbol).$append;

      return self::showSalary($salary, $symbol).' - '.self::showSalary($salary_max, $symbol).$append;
    }

    if(empty($salary) AND !empty($salary_max))
      return self::showSalary(number_format($salary_max, $decimal, $sep_dec, $sep_tho), $symbol).$append;
    if($salary_max<=$salary)
      return self::showSalary(number_format($salary, $decimal, $sep_dec, $sep_tho), $symbol).$append;
    return self::showSalary(number_format($salary, $decimal, $sep_dec, $sep_tho), $symbol).' - '.self::showSalary(number_format($salary_max, $decimal, $sep_dec, $sep_tho), $symbol).$append;
  }
  protected static function showSalary($salary, $symbol) {
    if(strpos($symbol, '%s') !== false) {
      return sprintf($symbol, $salary);
    }
    return $symbol.$salary;
  }
}
}
?>
