;(function($) {
  "use strict";
  $(document).ready(function (){
    $('.field-enabled').on('change', function () {
      if(this.checked) {
        $(this).parents('.taxonomy-item, .enabled-parent').addClass('is-enabled');
      } else {
        $(this).parents('.taxonomy-item, .enabled-parent').removeClass('is-enabled');
      }
    }).trigger('change');
    $('.wpjb_api-container').on('change', '.field-default_enabled', function () {
      if($(this).prop('checked')) {
        $(this).parent().prev().find('input.field-valid_required').prop('checked', false).trigger('change');
        $(this).parent().next().show('slow');
      } else {
        $(this).parent().next().hide('slow');
      }
    });
    $('.wpjb_api-container').on('change', '.field-valid_required', function () {
      if($(this).prop('checked') && $(this).parent().next().find('.field-default_enabled').length > 0) {
        $(this).parent().next().find('input.field-default_enabled').prop('checked', false).trigger('change');
      }
    });
    $('.wpjb_api-container').on('keyup change', '.copyable', function () {
      var tagName = $(this).prop('tagName');
      if($(this).val().length === 0 && $(this).next().is(tagName)) {
        $(this).next().focus();
        $(this).remove();
      } else if($(this).val().length > 0 && ($(this).next().length === 0 || !$(this).next().is(tagName))) {
        $(this).clone().val('').insertAfter(this);
      }
    });
    $('.wpjb_api-container').on('change keyup', '.field-meta_key', function () {
      if(this.value.length > 0) {
        $(this).parents('.itm-custmapping, .itm-mapping').addClass('is-enabled');
      } else {
        $(this).parents('.itm-custmapping, .itm-mapping').removeClass('is-enabled');
      }
    }).find('.field-meta_key').trigger('change');
    $('.wpjb_api-container').on('change', 'input.field-create_taxonomy', function () {
      if(this.checked) {
        $(this).parent().addClass('is-enabled');
      } else {
        $(this).parent().removeClass('is-enabled');
      }
    }).find('input.field-create_taxonomy').trigger('change');
    $('.wpjb_api_import_settings').on('click', function (e) {
      var fd = new FormData();
      fd.append('file', this.previousSibling.files[0]);
      fd.append('action', 'wpjb_api_import_settings');
      fd.append('_wpnonce', $(this).data('wpnonce'));

      $.ajax({
        type: "POST",
        url: ajaxurl,
        dataType: 'json',
        success: function (data) {
          // your callback here
          if(typeof data["redir"] !== 'undefined') {
            window.location.assign(data["redir"]);
          }
          if(typeof data["error"] !== "undefined") {
            $('.wpjb_api_import_settings').attr('data-error', data["error"]);
          } else {
            $('.wpjb_api_import_settings').attr('data-error', "");
          }
        },
        error: function (error) {
          // handle error
          var err = '';
          try {
            var js = JSON.parse(error.responseText);
            err = js['error'];
          } catch (e) {
            err = 'Unknown error ocurred';
          }
          $('.wpjb_api_import_settings').attr('data-error', err);
        },
        async: true,
        data: fd,
        cache: false,
        contentType: false,
        processData: false,
        timeout: 60000
      });
      e.preventDefault(true);
      e.stopPropagation(true);
      return false;
    });
  });
})(jQuery);
